diff --git a/libr/anal/fcn.c b/libr/anal/fcn.c
index 43b330f55a9..24c6b94a1cd 100644
--- a/libr/anal/fcn.c
+++ b/libr/anal/fcn.c
@@ -2132,7 +2132,7 @@ R_API RAnalBlock *r_anal_fcn_bbget(RAnalFunction *fcn, ut64 addr) {
 	RListIter *iter;
 	RAnalBlock *bb;
 	r_list_foreach (fcn->bbs, iter, bb) {
-		if (bb->addr == addr) {
+		if (addr >= bb->addr && addr < (bb->addr + bb->size)) {
 			return bb;
 		}
 	}
diff --git a/libr/core/cmd_print.c b/libr/core/cmd_print.c
index a3d658a4fa5..4ce024a5efb 100644
--- a/libr/core/cmd_print.c
+++ b/libr/core/cmd_print.c
@@ -4293,8 +4293,15 @@ static int cmd_print(void *data, const char *input) {
 					if (bbsum + 4096 < linear) {
 						eprintf ("Linear size differs too much from the bbsum, please use pdr instead.\n");
 					} else {
-						r_core_cmdf (core, "pD %d @ 0x%08" PFMT64x,
-							f->_size > 0 ? f->_size: r_anal_fcn_realsize (f), f->addr);
+						ut64 at = f->addr;
+						ut64 sz = f->_size > 0 ? f->_size : r_anal_fcn_realsize (f);
+						ut8 *buf = calloc (sz, 1);
+						(void)r_io_read_at (core->io, at, buf, sz);
+						r_core_print_disasm_function (core, f);
+						core->num->value = r_core_print_disasm (core->print, core, at, buf, sz, sz, 0, 1, 0);
+						r_core_print_disasm_function (core, NULL);
+						free (buf);
+						// r_core_cmdf (core, "pD %d @ 0x%08" PFMT64x, f->_size > 0 ? f->_size: r_anal_fcn_realsize (f), f->addr);
 					}
 #if 0
 					for (; locs_it && (tmp_func = locs_it->data); locs_it = locs_it->n) {
@@ -4379,8 +4386,9 @@ static int cmd_print(void *data, const char *input) {
 				if (block1) {
 					if (*input == 'D') { // pD
 						free (block1);
-						if (!(block1 = malloc (l)))
+						if (!(block1 = malloc (l))) {
 							break;
+						}
 						r_core_read_at (core, addr - l, block1, l); // core->blocksize);
 						core->num->value = r_core_print_disasm (core->print, core, addr - l, block1, l, l, 0, 1, formatted_json);
 					} else { // pd
@@ -4400,10 +4408,10 @@ static int cmd_print(void *data, const char *input) {
 						r_core_seek (core, prevaddr - instr_len, true);
 						memcpy (block1, block, bs);
 						if (bs1 > bs) {
-							r_core_read_at (core, addr + bs / addrbytes, block1 + (bs - bs % addrbytes),
-															bs1 - (bs - bs % addrbytes));
+							r_core_read_at (core, addr + bs / addrbytes,
+								block1 + (bs - bs % addrbytes),
+								bs1 - (bs - bs % addrbytes));
 						}
-
 						core->num->value = r_core_print_disasm (core->print,
 							core, core->offset, block1, bs1, l, 0, 1, formatted_json);
 						r_core_seek (core, prevaddr, true);
@@ -4436,13 +4444,15 @@ static int cmd_print(void *data, const char *input) {
 				} else {
 					int bs1 = l * 16;
 					block1 = malloc (R_MAX (bs, bs1));
-					memcpy (block1, block, bs);
-					if (bs1 > bs) {
-						r_core_read_at (core, addr + bs / addrbytes, block1 + (bs - bs % addrbytes),
-													  bs1 - (bs - bs % addrbytes));
+					if (block1) {
+						memcpy (block1, block, bs);
+						if (bs1 > bs) {
+							r_core_read_at (core, addr + bs / addrbytes, block1 + (bs - bs % addrbytes),
+									bs1 - (bs - bs % addrbytes));
+						}
+						core->num->value = r_core_print_disasm (core->print,
+								core, addr, block1, bs1, l, 0, 0, formatted_json);
 					}
-					core->num->value = r_core_print_disasm (core->print,
-						core, addr, block1, bs1, l, 0, 0, formatted_json);
 				}
 			}
 			free (block1);
diff --git a/libr/core/disasm.c b/libr/core/disasm.c
index 599f8772c19..1268a3fd074 100644
--- a/libr/core/disasm.c
+++ b/libr/core/disasm.c
@@ -237,6 +237,7 @@ typedef struct {
 	RAsmOp asmop;
 	RAnalOp analop;
 	RAnalFunction *fcn;
+	RAnalFunction *pdf;
 	const ut8 *buf;
 	int len;
 	int maxrefs;
@@ -4382,6 +4383,12 @@ static void ds_end_line_highlight(RDisasmState *ds) {
 	}
 }
 
+RAnalFunction *pdf = NULL;
+
+R_API void r_core_print_disasm_function(RCore *core, RAnalFunction *f) {
+	pdf = f;
+}
+
 // int l is for lines
 R_API int r_core_print_disasm(RPrint *p, RCore *core, ut64 addr, ut8 *buf, int len, int l, int invbreak, int cbytes, bool json) {
 	int continueoninvbreak = (len == l) && invbreak;
@@ -4404,6 +4411,7 @@ R_API int r_core_print_disasm(RPrint *p, RCore *core, ut64 addr, ut8 *buf, int l
 	ds->hint = NULL;
 	ds->use_json = json;
 	ds->first_line = true;
+	ds->pdf = pdf;
 
 	// disable row_offsets to prevent other commands to overwrite computed info
 	p->calc_row_offsets = false;
@@ -4610,6 +4618,19 @@ R_API int r_core_print_disasm(RPrint *p, RCore *core, ut64 addr, ut8 *buf, int l
 		if (skip_bytes && ds->midflags == R_MIDFLAGS_SHOW) {
 			ds->at -= skip_bytes;
 		}
+		if (ds->pdf) {
+			static bool sparse = false;
+			if (!r_anal_fcn_bbget (ds->pdf, ds->at)) {
+				inc = ds->oplen;
+				r_anal_op_fini (&ds->analop);
+				if (!sparse) {
+					r_cons_printf ("..\n");
+					sparse = true;
+				}
+				continue;
+			}
+			sparse = false;
+		}
 		ds_control_flow_comments (ds);
 		ds_adistrick_comments (ds);
 		/* XXX: This is really cpu consuming.. need to be fixed */
diff --git a/libr/include/r_anal.h b/libr/include/r_anal.h
index fda00a41280..425ba7a52ee 100644
--- a/libr/include/r_anal.h
+++ b/libr/include/r_anal.h
@@ -1394,8 +1394,7 @@ R_ANAL_FCN_VARKIND_LOCAL, z)
 
 
 R_API int r_anal_fcn_var_del_bydelta (RAnal *a, ut64 fna, const char kind, int scope, ut32 delta);
-R_API int r_anal_fcn_var_del_byindex (RAnal *a, ut64 fna, const char kind,
-		int scope, ut32 idx);
+R_API int r_anal_fcn_var_del_byindex (RAnal *a, ut64 fna, const char kind, int scope, ut32 idx);
 /* args */
 R_API int r_anal_var_count(RAnal *a, RAnalFunction *fcn, int kind, int type);
 
@@ -1417,6 +1416,7 @@ R_API char *r_anal_fcn_to_string(RAnal *a, RAnalFunction* fs);
 R_API int r_anal_str_to_fcn(RAnal *a, RAnalFunction *f, const char *_str);
 R_API int r_anal_fcn_count (RAnal *a, ut64 from, ut64 to);
 R_API RAnalBlock *r_anal_fcn_bbget(RAnalFunction *fcn, ut64 addr);
+R_API bool r_anal_fcn_contains(RAnalFunction *fcn, ut64 addr);
 R_API bool r_anal_fcn_bbadd(RAnalFunction *fcn, RAnalBlock *bb);
 R_API int r_anal_fcn_resize (const RAnal *anal, RAnalFunction *fcn, int newsize);
 
